#include "zcommon.acs"
#library "buttpain"
#include "commonFuncs.h"
#include "buttconst.h"

// Functions
Function int GetVelocity(void) {
    int vel;
    int x = GetActorVelX(0);
    int y = GetActorVelY(0);
    int angle = VectorAngle(x, y);

    if(((angle + 0.125) % 0.5) > 0.25) {
        vel = FixedDiv(y, Sin(angle));
    } else {
        vel = FixedDiv(x, Cos(angle));
    }
    return vel >> 16;
}

// Scripts
Script BUTT_WALKING1 ENTER
{
    int DelayTime, StepVolume, i, SoundPlayed;
    While(1)
    {
        Delay(1);
        DelayTime = 16 - GetVelocity() / 2;
        StepVolume = 6 * GetVelocity();
        if(GetActorZ(0) - GetActorFloorZ(0) == 0)
        {
            for(i=0; i<MaxStepSounds; i++)
            {
                if(CheckActorFloorTexture(0, StepSound[i][0]))
                {
                    ActivatorSound(StepSound[i][1], StepVolume);
                    SoundPlayed = 1;
                }
            }
            if(SoundPlayed == 0)
            {
                ActivatorSound(DefStepSound, StepVolume);
            }
        }
        SoundPlayed = 0;
        Delay(DelayTime);
    }
}

Script BUTT_WALKING2 (void)
{
    int i, SoundPlayed;
    if(GetActorZ(0) - GetActorFloorZ(0) == 0)
    {
        for(i=0; i<MaxStepSounds; i++)
        {
            if(CheckActorFloorTexture(0, StepSound[i][0]))
            {
                ActivatorSound(StepSound[i][1], 127);
                SoundPlayed = 1;
        }    
    }
        if(SoundPlayed == 0)
        {
            ActivatorSound(DefStepSound, 127);
        }
        SoundPlayed = 0;
    }
}

script BUTT_ENTER ENTER
{
    int x;
    int y;
    int z;
    int x2;
    int y2;

    // Let's get this out of the way first. For removing Skulltag/LMS shit.
    TakeInventory("Fist",0x7FFFFFFF);
    TakeInventory("Pistol",0x7FFFFFFF);
    TakeInventory("Railgun",0x7FFFFFFF);
    TakeInventory("Minigun",0x7FFFFFFF);
    TakeInventory("GrenadeLauncher",0x7FFFFFFF);

    GiveInventory("LevelCount",1);
    TakeInventory("LevelTimer",0x7FFFFFFF);
    if (GetCvar("butt_nolevelcurve") == 1) { GiveInventory("LevelCount",100); }
    if (isFreeForAll()) { GiveInventory("LevelCount",100); }
    GiveInventory("Medikit",100);
    GiveInventory("RunningStamina",175);
    GiveInventory("InitialProtection",210);
    FadeRange(0,0,0,1.00,0,0,0,0,3.50);

    Thing_ChangeTID(0, 1000 + PlayerNumber());

    delay(1);

    if (isFreeForAll() && (PlayerNumber() == 0 || PlayerNumber() == 4 || PlayerNumber() == 8 || PlayerNumber() == 12 || PlayerNumber() == 16))
    {
        GiveActorInventory(1000,"LMSMonsterSpawner",1); // If two players are present.
        /*GiveActorInventory(1003,"LMSMonsterSpawner",1); // If four are present.
        GiveActorInventory(1006,"LMSMonsterSpawner",1); // If seven are present.
        GiveActorInventory(1009,"LMSMonsterSpawner",1); // If ten are present.
        GiveActorInventory(1012,"LMSMonsterSpawner",1); // If thirteen are present.*/
        // Actually, no. If there are more players in the game, the leveltimer checks below will certainly take care of them.
    }

    while (1)
    {

    if (isFreeForAll())
    {
    str class2 = "BlankPuff";
    if (!random(0,34))
       class2 = "ThatWhichSwarmsAroundLMS";

        x2 = x;
        y2 = y;
        x = GetActorX(0);
        y = GetActorY(0);
        z = GetActorZ(0) + 10.0;
        int angle = GetActorAngle(0) >> 8;

        if ((x2 == x) && (y2 == y)) { GiveInventory("CampingFucker",1); } else { TakeInventory("CampingFucker",1); }
        if (CheckInventory("CampingFucker") >= 525) { Spawn(class2, x, y, z, 0, angle); }
    }

    if (flashlightOn[PlayerNumber()])
    { if (CheckInventory("SprintDash") == 0) 
      { GiveInventory("FlashlightSpawner", 1); }
    else
      { GiveInventory("FlashlightSpawnerRun",1); }
    }

    if (flashtorchOn[PlayerNumber()]) 
      { GiveInventory("FlashtorchSpawner", 1); }

    if (GetCvar("butt_infinitelight") == 1) { GiveInventory("FlashBattery",2); }

    TakeInventory("InitialProtection",1);

    GiveInventory("LevelTimer",1);

    if (CheckInventory("LevelTimer") == 6300) { if (isCoop() || isSinglePlayer()) { GiveInventory("MakeAnotherShadow3",1); } else { GiveActorInventory(1000,"LMSMonsterSpawner2",1); } } // Three minutes in a level.
    if (CheckInventory("LevelTimer") == 12600) { if (isCoop() || isSinglePlayer()) { GiveInventory("MakeAnotherShadow3",1); } else { GiveActorInventory(1000,"LMSMonsterSpawner2",1); } } // Six minutes.
    if (CheckInventory("LevelTimer") == 18900) { if (isCoop() || isSinglePlayer()) { GiveInventory("MakeAnotherShadow3",1); } else { GiveActorInventory(1000,"LMSMonsterSpawner2",1); } } // Nine minutes.
    if (CheckInventory("LevelTimer") == 25200) { if (isCoop() || isSinglePlayer()) { GiveInventory("MakeAnotherShadow3",1); } else { GiveActorInventory(1000,"LMSMonsterSpawner2",1); } } // 12 minutes.
    if (CheckInventory("LevelTimer") == 31500) { if (isCoop() || isSinglePlayer()) { GiveInventory("MakeAnotherShadow3",1); } else { GiveActorInventory(1000,"LMSMonsterSpawner2",1); } } // 15 minutes.
    if (CheckInventory("LevelTimer") == 37800) { if (isCoop() || isSinglePlayer()) { GiveInventory("MakeAnotherShadow3",1); } else { GiveActorInventory(1000,"LMSMonsterSpawner2",1); } } // 18 minutes.
    if (CheckInventory("LevelTimer") == 42000) { if (isCoop() || isSinglePlayer()) { GiveInventory("MakeAnotherShadow3",1); } else { GiveActorInventory(1000,"LMSMonsterSpawner2",1); } } // 20 minutes. Why are you still in a level?

    delay(1);
    }
}

script BUTT_ENTER_HEALF ENTER
{
    while (1)
    {
    delay(35);
    if (CheckInventory("Health") < 31 && CheckInventory("Health") > 0)
        { FadeRange(255,0,0,0.25,0,0,0,0,0.75); ActivatorSound("heartbeat",127); }

    if (CheckInventory("SprintDash") == 0) { GiveInventory("RunningStamina",5); } // Not health related, but why not?
    }
}

script BUTT_ENTER_RUN ENTER
{
    int buttons;

    while (1)
    {
    buttons = GetPlayerInput(-1, INPUT_BUTTONS);

    if (buttons & BT_SPEED)
    {
        if (CheckInventory("RunningStamina") > 0)
        {
            if (CheckInventory("WeaponIdle") == 1)
            {
                GiveInventory("SprintDash",1);
                TakeInventory("RunningStamina",1);
            }
            else
            { TakeInventory("SprintDash",1); }
        }
        else
        {
            TakeInventory("SprintDash",1);
            ActivatorSound("player/pant",127);
            delay(35);
        }
    }
    else
    { TakeInventory("SprintDash",1); }

    delay(1);
    }
}

script BUTT_OPEN OPEN
{
    int i;
    int levelmusic;

    SetMusic("D_SILENT");
    if (isFreeForAll())
    {
        levelmusic = random(0, LMSMUS-1);
        SetMusic(LMSMusList[levelmusic],0);
    }

    if (!GetCVar("butt_infinitelight"))
    {
        ConsoleCommand("set butt_infinitelight 0");
        ConsoleCommand("archivecvar butt_infinitelight");
    }

    if (!GetCVar("butt_nolevelcurve"))
    {
        ConsoleCommand("set butt_nolevelcurve 0");
        ConsoleCommand("archivecvar butt_nolevelcurve");
    }

    if (!GetCvar("compat_clientssendfullbuttoninfo")) { ConsoleCommand("set compat_clientssendfullbuttoninfo 1"); }

    while (1)
    {
        for (i = 0; i < MAXSECTORS; i++)
        {
            //Log(d:i, s:": ", d:GetSectorLightLevel(i));
            if (GetSectorLightLevel(i) > 0)
            {
                Light_ChangeToValue(i, 0);
                Sector_SetFade(i, 0,0,0);
                Light_Stop(i);
            }
 
            if (i % DELAYSECTOR == DELAYSECTOR-1) { Delay(1); }
        }
    }
}

Script BUTT_LIGHTPITCH (void)
{
    SetResultValue(GetActorPitch(0) / -182);
}

Script BUTT_LIGHTTOGGLE (int light)
{
    switch (light)
    {
    case 0:
        flashlightOn[PlayerNumber()] = 0;
        break;

    case 1:
        flashlightOn[PlayerNumber()] = 1;
        break;

    case 2:
        flashtorchOn[PlayerNumber()] = 0;
        break;

    case 3:
        flashtorchOn[PlayerNumber()] = 1;
        break;

    case 4:
        //print(s:"I work!");
        delay(random(70,350));
        GiveInventory("MakeAnotherShadow2",1);
        break;
    }
}

script BUTT_OPEN_CLIENT OPEN CLIENTSIDE
{
    if (!GetCVar("butt_cl_nochanges"))
    {
        ConsoleCommand("set butt_cl_nochanges 0");
        ConsoleCommand("archivecvar butt_cl_nochanges");
    }
}

script BUTT_ENTER_CLIENT ENTER CLIENTSIDE
{
    while (1)
    {
        if (GetCvar("butt_cl_nochanges") == 0)
        {
        consoleCommand("gl_light_ambient 20");
        consoleCommand("gl_fogmode 1");
        consoleCommand("gl_lightmode 1");
        }
    delay(1);
    }
}

script BUTT_ENTER_LIGHT ENTER
{
While (1)
{
   str class = "BlankPuff";
   if (!random(0,4))
       class = "ThatWhichSwarmsAround";

   if (CheckInventory("FlashBattery") > 0)
   { delay(350); }
   else
   {
       do
       {
           delay(random(105,350));
           int xb = GetActorX(0);
           int yb = GetActorY(0);
           int zb = GetActorZ(0) + 10.0;
           int angle = GetActorAngle(0) >> 8;
       }
       until (Spawn(class, xb, yb, zb, 0, angle));
   }
}
}